.data												#Data segment begins
kernel:												#Define labels for some strings
	.asciz	"[Kernel]-> "							
testing:
	.asciz	"Running a trivial test... "
works:
	.asciz	"Seems Ok. Now go get some sleep :)."
not:
	.asciz	"*Failed*"
newline:											#Manually define a string
	.byte 10
	.byte 13
	.byte 0
result:												#Define a word
	.word 1000
.text												#Code segment begins
.code16												#Real mode
.globl _start										#Make _start label global
	#
	#This program makes 1000 nested calls to trivialTest.
	#Each time the test returns, ax is increment from
	#zero back up to 1000.  If ax==1000, then we consider
	#this a successful test of a properly setup stack, etc.
	#
_start:												#Start of program
	pushw	%bp										#Push word in bp onto stack
	movw	%sp,%bp									#Copy word in sp to bp
	pushw	$newline								#Push addr. of label newline onto stack
	call	displayString							#Call displayString routine
	pushw	$kernel									#etc.
	call	displayString
	pushw	$testing
	call	displayString
	pushw	$1000									#Push word 1000 onto stack
	call	trivialTest								#Call the trivialTest routine
	addw	$8,%sp									#Add 8 to word in sp (pop 4 words)
	cmpw	%ax,result								#Compare word in ax to word at addr. result
	jne	.L6											#If not equal, jump to L6
	pushw	$works									#Push working string
	jmp	.L12										#Else jump to L12
.L6:
	pushw	$not									#Push failure string
.L12:
	call	displayString							#Display the test result
	addw	$2,%sp									#Add 2 to sp (pop 1 word)
	pushw	$newline								#etc.
	call	displayString
	addw    $2,%sp
.L8:												#Loop endlessly
	jmp .L8

trivialTest:
	pushw	%bp										#Save bp on stack
	movw	%sp,%bp									#Setup new bp
	movw	4(%bp),%ax								#Put word on top stack into ax
	testw	%ax,%ax									#Test ax
	jg	.L2											#If >0 jump to L2
	xorw	%ax,%ax									#Else zero out ax
	popw	%bp										#Restore bp
	retw											#Return
.L2:
	decw	%ax										#Decrement ax
	pushw	%ax										#Push ax onto stack
	call	trivialTest								#Call recursively
	addw	$2,%sp									#Add 2 to sp (pop 1 word)
	incw	%ax										#Increment ax
	popw	%bp										#Restore bp
	retw											#Return


displayString:
	pushw	%bp
	movw	%sp,%bp
	pushw	%ax
	pushw	%bx
	pushw	%si
	xorw	%si,%si									
	movw	4(%bp),%si								#Put addr. of string into si
	cmpb	$0,(%si)								#Compare first byte with 0
	je	done										#If = then jump to done
loop:												#Else loop over remaining bytes
	movb	(%si),%al								#Put byte at (si) into al
	movb	$14,%ah									#See webpage for 0x10 interupt registers
	movw	$0x0002,%bx
	int	$0x10										#Call 0x10 interupt
	incw    %si										#Increment si (addr. of next byte)
	cmpb	$0,(%si)								#Repeate if byte != 0
	jne	loop
done:
	popw	%si										#Restore registers...
	popw	%bx
	popw	%ax
	popw	%bp
	retw

